package java.net;

import sun.net.util.IPAddressUtil;
import java.io.IOException;

public abstract class URLStreamHandler
{
    public URLStreamHandler() {
    }
    
    protected abstract URLConnection openConnection(URL p0) throws IOException;
    
    protected URLConnection openConnection(URL url, Proxy proxy) throws IOException {
        throw new UnsupportedOperationException("Method not implemented.");
    }
    
    protected void parseURL(URL url, String substring, int beginIndex, int n) {
        String protocol = url.getProtocol();
        String authority = url.getAuthority();
        String s = url.getUserInfo();
        String str = url.getHost();
        int i = url.getPort();
        String s2 = url.getPath();
        String s3 = url.getQuery();
        String ref = url.getRef();
        boolean n2 = false;
        int n3 = 0;
        if (beginIndex < n) {
            int index = substring.indexOf(63);
            n3 = (index == beginIndex);
            if (index != -1 && index < n) {
                s3 = substring.substring(index + 1, n);
                if (n > index) {
                    n = index;
                }
                substring = substring.substring(0, index);
            }
        }
        if ((beginIndex > n - 4 || substring.charAt(beginIndex) != '/' || substring.charAt(beginIndex + 1) != '/' || substring.charAt(beginIndex + 2) != '/' || substring.charAt(beginIndex + 3) != '/') && beginIndex <= n - 2 && substring.charAt(beginIndex) == '/' && substring.charAt(beginIndex + 1) == '/') {
            beginIndex += 2;
            int endIndex = substring.indexOf(47, beginIndex);
            if (endIndex < 0 || endIndex > n) {
                endIndex = substring.indexOf(63, beginIndex);
                if (endIndex < 0 || endIndex > n) {
                    endIndex = n;
                }
            }
            authority = (str = substring.substring(beginIndex, endIndex));
            int index2 = authority.indexOf(64);
            if (index2 != -1) {
                if (index2 != authority.lastIndexOf(64)) {
                    s = null;
                    str = null;
                }
                else {
                    s = authority.substring(0, index2);
                    str = authority.substring(index2 + 1);
                }
            }
            else {
                s = null;
            }
            if (str != null) {
                if (str.length() > 0 && str.charAt(0) == '[') {
                    int index4;
                    if ((index4 = str.indexOf(93)) > 2) {
                        str = str.substring(0, index4 + 1);
                        if (!IPAddressUtil.isIPv6LiteralAddress(str.substring(1, index4))) {
                            throw new IllegalArgumentException("Invalid host: " + str);
                        }
                        i = -1;
                        if (str.length() > index4 + 1) {
                            if (str.charAt(index4 + 1) == ':') {
                                ++index4;
                                if (str.length() > index4 + 1) {
                                    i = Integer.parseInt(str.substring(index4 + 1));
                                }
                            }
                            else {
                                throw new IllegalArgumentException("Invalid authority field: " + authority);
                            }
                        }
                    }
                    else {
                        throw new IllegalArgumentException("Invalid authority field: " + authority);
                    }
                }
                else {
                    int index3 = str.indexOf(58);
                    i = -1;
                    if (index3 >= 0) {
                        if (str.length() > index3 + 1) {
                            i = Integer.parseInt(str.substring(index3 + 1));
                        }
                        str = str.substring(0, index3);
                    }
                }
            }
            else {
                str = "";
            }
            if (i < -1) {
                throw new IllegalArgumentException("Invalid port number :" + i);
            }
            beginIndex = endIndex;
            if (authority != null && authority.length() > 0) {
                s2 = "";
            }
        }
        if (str == null) {
            str = "";
        }
        if (beginIndex < n) {
            if (substring.charAt(beginIndex) == '/') {
                s2 = substring.substring(beginIndex, n);
            }
            else if (s2 != null && s2.length() > 0) {
                n2 = true;
                int lastIndex2 = s2.lastIndexOf(47);
                String str2 = "";
                if (lastIndex2 == -1 && authority != null) {
                    str2 = "/";
                }
                s2 = s2.substring(0, lastIndex2 + 1) + str2 + substring.substring(beginIndex, n);
            }
            else {
                s2 = ((authority != null) ? "/" : "") + substring.substring(beginIndex, n);
            }
        }
        else if (n3 != 0 && s2 != null) {
            int lastIndex = s2.lastIndexOf(47);
            if (lastIndex < 0) {
                lastIndex = 0;
            }
            s2 = s2.substring(0, lastIndex) + "/";
        }
        if (s2 == null) {
            s2 = "";
        }
        if (!(n2 == 0)) {
            int index5;
            while ((index5 = s2.indexOf("/./")) >= 0) {
                s2 = s2.substring(0, index5) + s2.substring(index5 + 2);
            }
            int fromIndex = 0;
            int index6;
            while ((index6 = s2.indexOf("/../", fromIndex)) >= 0) {
                if (index6 > 0 && (n = s2.lastIndexOf(47, index6 - 1)) >= 0 && s2.indexOf("/../", n) != 0) {
                    s2 = s2.substring(0, n) + s2.substring(index6 + 3);
                    fromIndex = 0;
                }
                else {
                    fromIndex = index6 + 3;
                }
            }
            while (s2.endsWith("/..") && (n = s2.lastIndexOf(47, s2.indexOf("/..") - 1)) >= 0) {
                s2 = s2.substring(0, n + 1);
            }
            if (s2.startsWith("./") && s2.length() > 2) {
                s2 = s2.substring(2);
            }
            if (s2.endsWith("/.")) {
                s2 = s2.substring(0, s2.length() - 1);
            }
        }
        this.setURL(url, protocol, str, i, authority, s, s2, s3, ref);
    }
    
    protected int getDefaultPort() {
        return -1;
    }
    
    protected boolean equals(URL url, URL url2) {
        String ref = url.getRef();
        String ref2 = url2.getRef();
        return (ref == ref2 || (ref != null && ref.equals(ref2))) && this.sameFile(url, url2);
    }
    
    protected int hashCode(URL url) {
        int n = 0;
        String protocol = url.getProtocol();
        if (protocol != null) {
            n += protocol.hashCode();
        }
        InetAddress hostAddress = this.getHostAddress(url);
        if (hostAddress != null) {
            n += hostAddress.hashCode();
        }
        else {
            String host = url.getHost();
            if (host != null) {
                n += host.toLowerCase().hashCode();
            }
        }
        String file = url.getFile();
        if (file != null) {
            n += file.hashCode();
        }
        int n2;
        if (url.getPort() == -1) {
            n2 = n + this.getDefaultPort();
        }
        else {
            n2 = n + url.getPort();
        }
        String ref = url.getRef();
        if (ref != null) {
            n2 += ref.hashCode();
        }
        return n2;
    }
    
    protected boolean sameFile(URL url, URL url2) {
        return (url.getProtocol() == url2.getProtocol() || (url.getProtocol() != null && url.getProtocol().equalsIgnoreCase(url2.getProtocol()))) && (url.getFile() == url2.getFile() || (url.getFile() != null && url.getFile().equals(url2.getFile()))) && ((url.getPort() != -1) ? url.getPort() : url.handler.getDefaultPort()) == ((url2.getPort() != -1) ? url2.getPort() : url2.handler.getDefaultPort()) && this.hostsEqual(url, url2);
    }
    
    protected synchronized InetAddress getHostAddress(URL url) {
        if (url.hostAddress != null) {
            return url.hostAddress;
        }
        String host = url.getHost();
        if (host == null || host.equals("")) {
            return null;
        }
        try {
            url.hostAddress = InetAddress.getByName(host);
        }
        catch (UnknownHostException ex) {
            return null;
        }
        catch (SecurityException ex2) {
            return null;
        }
        return url.hostAddress;
    }
    
    protected boolean hostsEqual(URL url, URL url2) {
        InetAddress hostAddress = this.getHostAddress(url);
        InetAddress hostAddress2 = this.getHostAddress(url2);
        if (hostAddress != null && hostAddress2 != null) {
            return hostAddress.equals(hostAddress2);
        }
        if (url.getHost() != null && url2.getHost() != null) {
            return url.getHost().equalsIgnoreCase(url2.getHost());
        }
        return url.getHost() == null && url2.getHost() == null;
    }
    
    protected String toExternalForm(URL url) {
        int capacity = url.getProtocol().length() + 1;
        if (url.getAuthority() != null && url.getAuthority().length() > 0) {
            capacity += 2 + url.getAuthority().length();
        }
        if (url.getPath() != null) {
            capacity += url.getPath().length();
        }
        if (url.getQuery() != null) {
            capacity += 1 + url.getQuery().length();
        }
        if (url.getRef() != null) {
            capacity += 1 + url.getRef().length();
        }
        StringBuffer o = new StringBuffer(capacity);
        o.append(url.getProtocol());
        o.append(":");
        if (url.getAuthority() != null && url.getAuthority().length() > 0) {
            o.append("//");
            o.append(url.getAuthority());
        }
        if (url.getPath() != null) {
            o.append(url.getPath());
        }
        if (url.getQuery() != null) {
            o.append('?');
            o.append(url.getQuery());
        }
        if (url.getRef() != null) {
            o.append("#");
            o.append(url.getRef());
        }
        return o.toString();
    }
    
    protected void setURL(URL url, String s, String host, int n, String s2, String s3, String s4, String s5, String s6) {
        if (this != url.handler) {
            throw new SecurityException("handler for url different from this handler");
        }
        if (host != null && url.isBuiltinStreamHandler(this)) {
            String checkHostString = IPAddressUtil.checkHostString(host);
            if (checkHostString != null) {
                throw new IllegalArgumentException(checkHostString);
            }
        }
        url.set(url.getProtocol(), host, n, s2, s3, s4, s5, s6);
        return;
    }
    
    @Deprecated
    protected void setURL(URL url, String s, String substring, int i, String s2, String s3) {
        String s4 = null;
        String substring2 = null;
        if (substring != null && substring.length() != 0) {
            s4 = ((i == -1) ? substring : (substring + ":" + i));
            int lastIndex = substring.lastIndexOf(64);
            if (lastIndex != -1) {
                substring2 = substring.substring(0, lastIndex);
                substring = substring.substring(lastIndex + 1);
            }
        }
        String substring3 = null;
        String substring4 = null;
        if (s2 != null) {
            int lastIndex2 = s2.lastIndexOf(63);
            if (lastIndex2 != -1) {
                substring4 = s2.substring(lastIndex2 + 1);
                substring3 = s2.substring(0, lastIndex2);
            }
            else {
                substring3 = s2;
            }
        }
        this.setURL(url, s, substring, i, s4, substring2, substring3, substring4, s3);
    }
}
